//  YAMF - "Yet Another Mouse Follower"
//  Author: Pat Thompson
//  Last Modified: February 15, 2007
//  Version: 1.05
//
// ------------------------------------------------------------------------
//       Copyright (C) 2001 ProjectIt - All Rights Reserved
//
// You have a royalty-free right to use, modify, reproduce and distribute
// the Sample Application Files (and/or any modified version) in any way
// you find useful, provided that you agree that ProjectIt has no warranty,
// obligations or liability for any Sample Application Files.
//
// Site: http://www.projectit.com
// ------------------------------------------------------------------------

// Set global browser boolean flags

var isIE	= document.all;
var isIE7	= isIE && window.XMLHttpRequest &&
		  window.ActiveXObject;
var isIE6	= isIE && document.implementation &&
		  !isIE7;
var isgteIE6	= isIE7 || isIE6;
var isIE5	= isIE && window.print && !isgteIE6; 
var isIEDOM2	= isIE5 || isgteIE6;
var isIE4	= isIE && !isIEDOM2 &&
		  navigator.cookieEnabled;
var isIE3	= isIE && !isIE4 && !isIEDOM2;
var isNS	= navigator.mimeTypes && !isIE;
var isNS3	= isNS && !navigator.language;
var isNS4	= document.layers;
var isNS6	= document.getElementById && !isIE;
var isNS7	= isNS6;
var isNS71	= document.designMode;
var isNSDOM2	= isNS6;
var isDOM2	= isIEDOM2 || isNSDOM2;

// YAMF Options defaults
// ** Can be overridden via YAMF function call **

var TailType = "banner";				// banner	| overlap

var TailEffect = "dither";				// dither	| blink
							// marquee	| pinwheel
							// rotate	| lockstep

var TailJustify = "left";				// right	| center
							// left

var TailDirection = "left";				// right	| left
var ImageOn = "visible";				// visible	| hidden
var TailAngleDeg = 0;					// degrees
var MoveRate = 50;					// milliseconds
var XGapAdj = 0;					// pixels
var YGapAdj = 0;					// pixels
var imageReverse = false;				// false	| true
var angAware = true;					// true		| false
var IMGsPath = "images/";				// URL path
var IMGsPrefix = "yamf";				// filename prefix
var IMGsExt = "gif";					// filename extension
var IMGsScale = 1;					// image scalar

// YAMF defaults
// ** Can NOT be overridden via YAMF function call **

var maxDChars = 25;					// maximum displayable images
var blinkRate = 1000;					// blink update rate
var marqueeRate = 150;					// marquee update rate
var sweepRate = 100;					// sweep update rate
var sweepAngle = 25;					// rotation angle increment

// Miscellaneous YAMF flags and variables
// ** DO NOT CHANGE! **

var cycleTimer = false;					// display update timer handle
var blinkTimer = false;					// blink update timer handle
var marqueeTimer = false;				// marquee update timer handle
var sweepTimer = false;					// sweep update timer handle
var TailReset = false;					// reset function flag

var RTE = "RTE";					// layer&image id&name handle
var blinkState = "hidden";				// blink visibility state
var mouseX = 0;						// current mouse X coordinate
var mouseY = 0;						// current mouse Y coordinate
var justifyX = 0;					// mouse X justification
var justifyY = 0;					// mouse Y justification
var prevTailAngle = TailAngleDeg;			// saves initial Tail Angle setting
var prevTailType = TailType;				// saves initial Tail Type setting
var prevReverse = imageReverse;				// saves initial image reverse setting
var marqueeMSG = "";					// message holder for marquee
var prevIMGsPath = IMGsPath+IMGsPrefix+IMGsExt;		// previous images' pathname
var RADIANS = Math.PI / 180.0;				// radian conversion factor

if (isNS4) {						// set visibility style
  var BHide = "hide";					// sheet identifiers
  var BShow = "show";					// for NS4 and NS6/IE
} else {
  var BHide = "hidden";
  var BShow = "visible";
}

// Define allowable alphanumerics and characters needing
// special filename designation.

var IMGs = "abcdefghijklmnopqrstuvwxyz`1234567890-=" +
           "~!@#$%^&*()_+,./;'[]\\<>?:\"{}| ";
var SpecialIMGs = "'|\\:.>#<\%\"?;/ *";
var SpecialIDs = new Array ( "apost",   "bar","bslash", "colon",
                               "dot",    "gt",  "hash",    "lt",
                             "pcent", "quote","riddle",  "semi",
                             "slash", "space",  "star");

var IMGsLen = IMGs.length;				// length of text image string
var TailAngleRad = TailAngleDeg * RADIANS;		// angle of tail (radians)
var cosAngle = Math.cos(TailAngleRad);			// tail width offset
var sinAngle = Math.sin(TailAngleRad);			// tail height offset
var MSGLength;						// entire message length
var nos;						// truncated message length
var Canvas = new Object();
    Canvas.Left = 0;				// canvas minimum width
    Canvas.Top = 0;				// canvas minimum height
    Canvas.Right = Number.MAX_VALUE;		// canvas maximum width
    Canvas.Bottom = Number.MAX_VALUE;		// canvas maximum height
    Canvas.xMiddle = Number.MAX_VALUE;		// canvas X center
    Canvas.yMiddle = Number.MAX_VALUE;		// canvas Y center
var IMGObjs = new Array();				// image array for caching
var loadedIMGs = 0;					// number of loaded images
var failedIMGs = 0;					// number of failed images
var IMGData = new Array();				// images metrics array
							// 0-URL	| 1-X offset
							// 2-Y offset
var MIdxs = new Array();				// message order indexes

// Netscape 4 kludge needed to 
// - reset dynamic elements on a resize
// - start mouse move event handler

if (isNS4) {
  window.onResize = 'document.location.href = document.location;'
  document.captureEvents(Event.MOUSEMOVE);
}

loadFNArray();						// Cache all images
makeSprites();						// Create image containers

// Primary Entry Point

function YAMF(MESSAGE, OPTIONS) {
  var i;

  if (!(MESSAGE||OPTIONS))				// If null call
    return false;					//   ignore

  if (OPTIONS)						// Options?
    RTParseOpts(OPTIONS);				//   parse them

  if ((loadedIMGs+failedIMGs)<IMGsLen) {		// Defer until images loaded
    setTimeout("YAMF('"+MESSAGE+"')", 1000);		//   so image dimensions
    return false;					//   can be retrieved
  }

  getDisplayDims(Canvas);				// Get display canvas dimensions
  mouseX = Canvas.xMiddle;			// Set mouse X at mid-screen
  mouseY = Canvas.yMiddle;			// Set mouse Y at mid-screen

  if (cycleTimer) {					// If previous call active
    document.onmousemove = null;			//   grind it to a halt to
    clearInterval(cycleTimer);				//   prevent reentry while
    cycleTimer = false;					//   processing this request
    RTState("hidden");					// Hide message images
  }

  if (blinkTimer) {					// If within blink
    clearInterval(blinkTimer);				//   stop it
    blinkTimer = false;
  }
  if (marqueeTimer) {					// If within marquee
    clearInterval(marqueeTimer);			//   stop it
    marqueeTimer = false;
  }
  if (sweepTimer) {					// If within sweep
    clearInterval(sweepTimer);				//   stop it 
    sweepTimer = false;
    TailAngleDeg = prevTailAngle;			//   restore settings
    TailAngleRad = TailAngleDeg * RADIANS;		//     in effect before
    cosAngle = Math.cos(TailAngleRad);			//     sweep
    sinAngle = Math.sin(TailAngleRad);
    TailType = prevTailType;
    imageReverse = prevReverse;
  }

  if (TailReset) {

    TailType = "banner";				// banner	| overlap

    TailEffect = "dither";				// dither	| blink
							// marquee	| pinwheel
							// rotate	| lockstep

    TailJustify = "left";				// right	| center
							// left

    TailDirection = "left";				// right	| left
    ImageOn = "visible";				// visible	| hidden
    TailAngleDeg = 0;					// degrees
    MoveRate = 50;					// milliseconds
    XGapAdj = 0;					// pixels
    YGapAdj = 0;					// pixels
    imageReverse = false;				// false	| true
    angAware = true;					// true		| false
    IMGsPath = "images/";				// URL path
    IMGsPrefix = "yamf";				// filename prefix
    IMGsExt = "gif";					// filename extension
    IMGsScale = 1;					// image scalar

    TailAngleRad = TailAngleDeg * RADIANS;		// angle of tail (radians)
    cosAngle = Math.cos(TailAngleRad);			// tail width offset
    sinAngle = Math.sin(TailAngleRad);			// tail height offset

    RTState("hidden");
    TailReset = false;
    return true;
  }

  if (TailEffect=="blink")				// If blink
    blinkTimer = setInterval('blinkSprites()',		//   start it going
                              blinkRate);

  if (MESSAGE) {					// If message present

    if (failedIMGs>0)					// If bad images
      MESSAGE = cullBadChars(MESSAGE);			//   remove from Message

    MSGLength = MESSAGE.length				// Get full message length
    if (MSGLength<=0)					// If culled message empty
      return false;					//   exit

    nos = Math.min(MSGLength, maxDChars);		// Compute maximum displayable
    MESSAGE = MESSAGE.toLowerCase();			// Ensure alphas are lower case

    if (TailEffect=="marquee") {			// marquee request?
      marqueeMSG = "";
      for (i=0 ; i<maxDChars ; i++)			//   setup message
        marqueeMSG += " ";				//   marquee string
      if (TailDirection=="left")
        marqueeMSG += MESSAGE;
      else
        marqueeMSG = MESSAGE + marqueeMSG;
      marqueeTimer = setInterval('marqueeSprites()',	// Start marquee
                                  marqueeRate);
    } else if (TailEffect=="pinwheel" ||		// sweep request?
               TailEffect=="rotate") {			//   save settings in
      prevTailAngle = TailAngleDeg;			//   effect now for
      prevTailType = TailType;				//   later restoration
      prevReverse = imageReverse;
      sweepTimer = setInterval('sweepSprites()',	// Start sweeper
                                sweepRate);
    }

    toImageIdxs(MESSAGE);				// Set message indexes
  }

  setTail();						// Compute Tail
  RTState(ImageOn);					// Unhide message images
  startMouser();					// Start event handlers

  return true;
}

// Returns rectangular and center coordinates of renderable display

function getDisplayDims(CANVAS) {
  var CWidth, CHeight, CScrollX, CScrollY;

  if (isNS) {						// If Netscape
    CWidth = self.innerWidth;				//   save its canvas
    CHeight = self.innerHeight;				//   dimensions and
    CScrollX = window.pageXOffset;			//   scroll offset
    CScrollY = window.pageYOffset;			//   values
  } else if (isgteIE6) {					// If IE6
    CWidth = document.documentElement.clientWidth;	//   save its canvas
    CHeight = document.documentElement.clientHeight;	//   html dimensions
    if (CWidth==0) {					// If not in compliant mode
      CWidth = document.body.clientWidth;		//   save its canvas
      CHeight = document.body.clientHeight;		//   body dimensions
    }
    CScrollX = document.body.scrollLeft +		// Save
               document.documentElement.scrollLeft;	//   scroll
    CScrollY = document.body.scrollTop +		//     offset
               document.documentElement.scrollTop;	//       values
  } else if (isIE) {					// If IE
    CWidth = document.body.clientWidth;			//   save its canvas
    CHeight = document.body.clientHeight;		//   dimensions and
    CScrollX = document.body.scrollLeft;		//   scroll offset
    CScrollY = document.body.scrollTop;			//   values
  }
  CANVAS.Left    = CScrollX;				// Compute
  CANVAS.Right   = CWidth + CScrollX;			//   image
  CANVAS.Top     = CScrollY;				//     clipping
  CANVAS.Bottom  = CHeight + CScrollY;			//       window
  CANVAS.xMiddle = Math.round(CWidth/2) + CScrollX;	// Compute canvas
  CANVAS.yMiddle = Math.round(CHeight/2) + CScrollY;	//   center
}

// Cache all images

function loadFNArray() {
  var begpath, endpath, i, j, charID, temp;
  begpath = IMGsPath + IMGsPrefix;
  endpath = "." + IMGsExt;
  loadedIMGs = 0;
  failedIMGs = 0;
  for (i=0, j=0 ; i<IMGsLen ; i++, j+=3) {
    charID = IMGs.charAt(i);
    temp = SpecialIMGs.indexOf(charID);
    if (temp!=-1)
      charID = SpecialIDs[temp];
    IMGData[j] = begpath + charID + endpath;
    IMGObjs[i] = new Image();
    IMGObjs[i].onerror = logError;
    IMGObjs[i].onload = logLoad;
    IMGObjs[i].myComplete = false;
    IMGObjs[i].myError = false;
    IMGObjs[i].src = IMGData[j];
  }
}

// Creates CSS tags for all images and loads spaces initially.

function makeSprites() {
  var i, j, k, IMGSpace;
  k = IMGs.indexOf(" ");
  IMGSpace = IMGData[k*3];
  for (i=0, j=maxDChars-1 ; i<maxDChars ; i++, j--) {
    if (isNS4) {
      document.write("<layer id=" + RTE+i +
                     " z-index=" + j +
                     " visibility=" + BHide +
                     " left=0 top=0>");
      document.write("<img src='" + IMGSpace +
                     "' border=0 name=" + RTE+i+"I>");
      document.write("</layer>");
    } else {
      document.write("<div id=" + RTE+i + " style='" +
                     "zIndex:" + j + ";" +
                     "position:absolute;visibility:" +
                     BHide + ";display:none;" +
                     "left:0px;top:0px;'>");
      document.write("<img src='" + IMGSpace +
                     "' border=0 name=" + RTE+i+"I>");
      document.write("</div>");
    }
  }
}

// Enables/Disables images visibility

function RTState(VISIBLE) {
  var i;
  for (i=0 ; i<nos ; i++)
    eVisibility(RTE+i, VISIBLE);
}

// Parse Options

function RTParseOpts(OPTIONS) {

  var temp;

  if (getRE("type").exec(OPTIONS)) {			// Set Banner type
    temp = RegExp.rightContext;
    if (/^overlap/i.test(temp))
      TailType = "overlap";
    else if (/^banner/i.test(temp))
      TailType = "banner";
    else
      TailReset = /^off/i.test(temp);
  }

  if (getRE("effect").exec(OPTIONS)) {			// Set Effect type
    temp = RegExp.rightContext;
    if (/^dither/i.test(temp))
      TailEffect = "dither";
    else if (/^blink/i.test(temp))
      TailEffect = "blink";
    else if (/^marquee/i.test(temp))
      TailEffect = "marquee";
    else if (/^pinwheel/i.test(temp))
      TailEffect = "pinwheel";
    else if (/^rotate/i.test(temp))
      TailEffect = "rotate";
    else if (/^lockstep/i.test(temp))
      TailEffect = "lockstep";
  }

  if (getRE("direction").exec(OPTIONS)) {		// Set Effect direction
    temp = RegExp.rightContext;
    if (/^right/i.test(temp))
      TailDirection = "right";
    else if (/^left/i.test(temp))
      TailDirection = "left";
  }

  if (getRE("justify").exec(OPTIONS)) {			// Set mouse justification
    temp = RegExp.rightContext;
    if (/^left/i.test(temp))
      TailJustify = "left";
    else if (/^center/i.test(temp))
      TailJustify = "center";
    else if (/^right/i.test(temp))
      TailJustify = "right";
  }

  if (getRE("view").exec(OPTIONS)) {			// Set View mode
    temp = RegExp.rightContext;
    if (/^visible/i.test(temp))
      ImageOn = "visible";
    else if (/^hidden/i.test(temp))
      ImageOn = "hidden";
  }

  if (getRE("angle").exec(OPTIONS)) {			// Set Tail Angle
    if (/^\d*\.?\d*/.exec(RegExp.rightContext)) {
      TailAngleDeg = RegExp.lastMatch % 360;		// Ensure Tail Angle
      if (TailAngleDeg<0) TailAngleDeg += 360;		//   between 0-360
      TailAngleRad = TailAngleDeg * RADIANS;		// Convert to radians
      cosAngle = Math.cos(TailAngleRad);
      sinAngle = Math.sin(TailAngleRad);
    }
  }

  if (getRE("rate").exec(OPTIONS)) {			// Set Move Rate
    if (/^\d+/.exec(RegExp.rightContext))
      MoveRate = Math.round(RegExp.lastMatch);
  }

  if (getRE("xgapadj").exec(OPTIONS)) {			// Set image X-direction
    if (/^\d+/.exec(RegExp.rightContext))		//   Gap adjustment
      XGapAdj = Math.round(RegExp.lastMatch);
  }

  if (getRE("ygapadj").exec(OPTIONS)) {			// Set image Y-direction
    if (/\d+/.exec(RegExp.rightContext))		//   Gap adjustment
      YGapAdj = Math.round(RegExp.lastMatch);
  }

  if (getRE("reverse").exec(OPTIONS))			// Set image display order
    imageReverse = /^true/i.test(RegExp.rightContext)
  if (getRE("angAware").exec(OPTIONS))			// Set Auto-Quad Reversal
    angAware = !/^false/i.test(RegExp.rightContext)

  if (getRE("ipath").exec(OPTIONS)) {			// Set images path
    if (/^[^\s"]+/.exec(RegExp.rightContext)) {
      IMGsPath = RegExp.lastMatch;
      if (!/\/$/.test(IMGsPath))
        IMGsPath += "/";
    }
  }
  if (getRE("iprefix").exec(OPTIONS)) {			// Set images prefix name
    if (/^[^\s"]+/.exec(RegExp.rightContext))
      IMGsPrefix = RegExp.lastMatch;
  }
  if (getRE("iext").exec(OPTIONS)) {			// Set images Extention
    if (/^[^\s"]+/.exec(RegExp.rightContext)) {
      IMGsExt = RegExp.lastMatch;
      if (IMGsExt.charAt(0)==".")
        IMGsExt = IMGsExt.substr(1);
    }
  }

  if (prevIMGsPath != IMGsPath+IMGsPrefix+IMGsExt) {	// If new Pathname
    loadFNArray();					//   cache those images
    prevIMGsPath = IMGsPath+IMGsPrefix+IMGsExt;
  }

  if (getRE("scale").exec(OPTIONS)) {			// Set image Scale factor
    if (/^\d*\.?\d*/.exec(RegExp.rightContext)) {
      IMGsScale = RegExp.lastMatch;
    }
  }
}

// Cull bad image character from Message string

function cullBadChars(TEXT) {
  var badIMGs, badChar, re;

  if (failedIMGs>0) {
    badIMGs="[";
    for (i=0 ; i<IMGsLen ; i++) {
      if (IMGObjs[i].myError) {
        badChar = IMGs.charAt(i);
        if (badChar=="/" || badChar=="[" ||
            badChar=="]" || badChar=="^")
          badIMGs+="\\";
        badIMGs+=badChar;
      }
    }
    badIMGs+="]";
    re = new RegExp();
    return TEXT.replace(re.compile(badIMGs,"gi"),"");
  }
}

// Create Message Image index array

function toImageIdxs(MESSAGE) {
  var i;

  imageReverse = imageReverse || (TailAngleDeg>90 &&	// Determine display
                 TailAngleDeg<=270 &&			//   order of message
                 angAware);				//   characters

  for (i=0 ; i<nos ; i++) {
    charID = MESSAGE.charAt(imageReverse?nos-i-1:i);	// Get character in
							//   display order
    MIdxs[i] = IMGs.indexOf(charID);			// If not found
    if (MIdxs[i]==-1) MIdxs[i] = IMGs.indexOf(" ");	//   set to space
    getIPtr(RTE+i).src = IMGObjs[MIdxs[i]].src
  }
}

// Computes the banner tail characteristics.

function setTail() {
  var i, j, newW, newH, oX, oY, totalX, totalY;

  totalX = totalY = justifyX = justifyY = 0;

  for (i=0 ; i<nos ; i++) {
    j = MIdxs[i];
    oX = j*3+1, oY = oX+1;

    IMG = getIPtr(RTE+i);				// Get Image pointer

    newW = IMGObjs[j].width;
    newH = IMGObjs[j].height;
    if (!isNS4) {					// Scale image
      newW *= IMGsScale;
      newH *= IMGsScale;
      IMG.width = Math.round(newW);
      IMG.height = Math.round(newH);
    }
    if (TailType=="banner") {				// Compute x,y offsets
      IMGData[oX] = cosAngle * newW; 			//   needed to produce
      IMGData[oY] = sinAngle * newH;			//   angled banner
      totalX += IMGData[oX];
      totalY += IMGData[oY];
    } else {
      IMGData[oX] = 0;					// No banner
      IMGData[oY] = 0;
    }
  }
  if (TailJustify=="left") {
    i = 0;
    justifyX = 0;
    justifyY = 0;
  } else if (TailJustify=="center") {
    i = Math.round((nos-1)/2);
    oX = MIdxs[i]*3+1, oY = oX+1;
    justifyX = -totalX/2;
    justifyY = -totalY/2;
  } else {
    i = nos-1;
    oX = MIdxs[i]*3+1, oY = oX+1;
    justifyX = -totalX;
    justifyY = -totalY;
  }
//  if (TailEffect=="pinwheel" || TailEffect=="rotate")
//    justifyY += IMGObjs[MIdxs[i]].height/2;
window.status=justifyX+" "+justifyY+" "+cosAngle+" "+sinAngle;
  totalX = mouseX+justifyX;
  totalY = mouseY+justifyY;

  moveContainer(RTE+0, totalX, totalY,
                -IMGObjs[MIdxs[0]].width,
                -IMGObjs[MIdxs[0]].height);

  if (TailEffect!="dither" &&
      TailEffect!="pinwheel") {
    for(i=1 ; i<nos ; i++) {
      oX = MIdxs[i-1]*3+1, oY = oX+1;
      totalX = getXpos(RTE+(i-1));
      totalY = getYpos(RTE+(i-1));
      moveContainer(RTE+i, totalX, totalY,
                    IMGData[oX], IMGData[oY]);
    }
  }
}

// Start cycler and set mousemove event handler

function startMouser() {
  document.onmousemove = newPos;			//  Define mouse move handler
  cycleTimer = setInterval("cycle()", MoveRate);	//  Start cycler
}

// Compile Regular Expression so global flag works repeatedly

function getRE (EXP) {
  var re = new RegExp();
  return re.compile(EXP+'\\s*=\\s*"*','gi');
}

// Set image loaded property and increment images loaded counter

function logLoad() {
  this.myComplete = true;
  ++loadedIMGs;
}

// Set image error property and increment images error counter

function logError() {
  this.myError = true;
  ++failedIMGs;
}

// Alternate visibility property to provide blink effect

function blinkSprites() {
  if (cycleTimer) {
    blinkState = (blinkState=="visible") ? "hidden" : "visible";
    RTState(blinkState);
  }
}

// Shift left/right one image at a time to simulate marquee

function marqueeSprites() {
  if (cycleTimer) {
    var temp;
    if (TailDirection=="left") {
      temp = marqueeMSG.charAt(0);
      marqueeMSG = marqueeMSG.substr(1, marqueeMSG.length) + temp;
    } else {
      temp = marqueeMSG.charAt(marqueeMSG.length-1);
      marqueeMSG = temp + marqueeMSG.substr(0, marqueeMSG.length-1);
    }
    toImageIdxs(marqueeMSG);
    setTail();
  }
}

// Change banner angle on each entry to simulate sweep

function sweepSprites() {
  if (cycleTimer) {
    if (TailDirection=="right")
      TailAngleDeg += sweepAngle;
    else
      TailAngleDeg -= sweepAngle;
    if (TailAngleDeg<0) TailAngleDeg += 360;
    TailAngleDeg %= 360;
    TailAngleRad = TailAngleDeg * RADIANS;
    cosAngle = Math.cos(TailAngleRad);
    sinAngle = Math.sin(TailAngleRad);
    setTail();
  }
}

// Return element pointer

function getEPtr(ID) {
  return isDOM2 ? document.getElementById(ID).style :
         (isNS4 ? document.layers[ID] :
                  document.all[ID].style);
}

// Return image pointer

function getIPtr(ID) {
  return isNS4 ? document.layers[ID].document.images[ID+"I"]
               : document.images[ID+"I"];
}

// Set element Visibility property.

function eVisibility (N, VISIBLE) {
  var e = getEPtr(N);

  if (VISIBLE=="visible") {
    e.visibility = BShow;
    if (!isNS4) e.display = "inline";
  } else {
    e.visibility = BHide;
    if (!isNS4) e.display = "none";
  }
}

// Returns passed image's current X positon

function getXpos(N) {
  return parseInt(getEPtr(N).left);
}

// Returns passed image's current Y positon

function getYpos(N) {
  return parseInt(getEPtr(N).top);
}

// Moves passed image:
//   DX,Y  - new x,y
//   OFFSETX,Y   - x,y offsets that create banner tail effect
//   X,YGapAdj   - used to fine-tune gap between images

function moveContainer(N, DX, DY, OFFSETX, OFFSETY) {
  var e = getEPtr(N);

  var coordX = Math.round(DX + OFFSETX + XGapAdj);
  var coordY = Math.round(DY + OFFSETY + YGapAdj);

  if (isDOM2 || isIE4) {
    var i = getIPtr(N);
    if (coordX          < Canvas.Left   ||		// If outside canvas area
        coordX+i.width  > Canvas.Right  ||		//   hide images
        coordY          < Canvas.Top    ||
        coordY+i.height > Canvas.Bottom)
      e.display = "none";
    else
      e.display = "inline";
    e.left = coordX+"px";
    e.top  = coordY+"px";
  } else {
    e.left = coordX;
    e.top  = coordY;
  }
}

// Traverses images, moving previous-to-next one's position.
// Dither effect created by going from last-to-first image with
// the first image always representing current mouse position.

function cycle() {
  var i, j, oX, oY, prevX, prevY;
  if (TailEffect=="dither" ||
      TailEffect=="pinwheel") {
    for(i=nos-1 ; i>0 ; i--) {
      oX = MIdxs[i-1]*3+1, oY = oX+1;
      prevX = getXpos(RTE+(i-1));
      prevY = getYpos(RTE+(i-1));
      moveContainer(RTE+i, prevX, prevY,
                    IMGData[oX], IMGData[oY]);
    }
  } else {
    for(i=1 ; i<nos ; i++) {
      oX = MIdxs[i-1]*3+1, oY = oX+1;
      prevX = getXpos(RTE+(i-1));
      prevY = getYpos(RTE+(i-1));
      moveContainer(RTE+i, prevX, prevY,
                    IMGData[oX], IMGData[oY]);
    }
  }
}

// Moves first image to new mouse position.

function newPos(E) {

  mouseX = (isNS4) ? E.pageX :
           (isgteIE6) ? event.clientX +
                     document.documentElement.scrollLeft +
                     document.body.scrollLeft :
           (isIE)  ? event.clientX + window.scrollX :
                     E.clientX + window.pageXOffset;
  mouseY = (isNS4) ? E.pageY :
           (isgteIE6) ? event.clientY +
                     document.documentElement.scrollTop +
                     document.body.scrollTop :
           (isIE)  ? event.clientY + window.scrollY :
                     E.clientY + window.pageYOffset;

  moveContainer(RTE+0, mouseX+justifyX, mouseY+justifyY,
                0,0);
}
